	.586
	.model flat,stdcall
	option casemap:none
	
		include windows.inc
		include user32.inc
		include kernel32.inc
		include gdi32.inc
		include comdlg32.inc

		include testbed.inc
	   
		includelib user32.lib
		includelib kernel32.lib
		includelib gdi32.lib
		includelib comdlg32.lib
	
		include masm32.inc
		includelib masm32.lib
		include debug.inc
		includelib debug.lib

		include ..\Ultrano\EasySound.inc
		includelib ..\Ultrano\EasySound.lib
	
	
		ID_EDITBOX	EQU 4000

		BUFFER_SIZE	EQU 100h*size WORD
	
	
	.data
		szClassName	db "MainWinClass",0
		szAppName	db "Testbed",0
		szInfoCaption	db "Module properties",0
		szEditCtrlClass	db "EDIT",0
		szBlankRow	db 0Dh,0Ah,0
		dwSampleRate	dd 44100

		lpMyNet		dd NULL
		szFileFilter	db "Binary networks",0,"*.bin",0
				db "all files",0,"*.*",0,0


	include binData1.inc


		fValue		SAMPLE 2.87558
		fMaxAmp		SAMPLE 32767.0
	
	.data?
		hInstance	HINSTANCE ?
		CommandLine	LPSTR ?
		lpString	dd ?
		hMainWnd	HWND ?
		hEditBox	HWND ?
		hFnt		dd ?
		hFile		HANDLE ?
		szFileName	db 260 dup (?)
	
		ofn		OPENFILENAME <>
	
		lpPot		dd ?
		Rect		RECT <>

		lpBuffer	dd ?
	
	
	.code
	
	start:
			invoke GetModuleHandle, NULL
			mov	hInstance,eax
			invoke GetCommandLine
			mov	CommandLine,eax
	
			invoke GlobalAlloc,GPTR,1024
			mov	lpString,eax

			invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
			invoke ExitProcess,0
	
	WinMain		PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hWnd:HWND
		
			mov	wc.cbSize,SIZEOF WNDCLASSEX
			mov	wc.style, CS_HREDRAW or CS_VREDRAW
			mov	wc.lpfnWndProc, offset WndProc
			mov	wc.cbClsExtra,NULL
			mov	wc.cbWndExtra,NULL
			push	hInstance
			pop	wc.hInstance
			mov	wc.hbrBackground,COLOR_BTNFACE+1
			mov	wc.lpszMenuName,NULL
			mov	wc.lpszClassName,offset szClassName
		
			invoke LoadIcon,NULL,IDI_APPLICATION
			mov	wc.hIcon,eax
			mov	wc.hIconSm,eax
		
			invoke LoadCursor,NULL,IDC_ARROW
			mov	wc.hCursor,eax
		
			invoke RegisterClassEx,addr wc
			INVOKE CreateWindowEx,NULL,offset szClassName,offset szAppName,
	           		WS_OVERLAPPEDWINDOW,
	           		CW_USEDEFAULT,CW_USEDEFAULT,
	           		CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,
	           		hInst,NULL
			mov	hWnd,eax
		
			invoke ShowWindow,hWnd,SW_SHOWNORMAL
			invoke UpdateWindow,hWnd
		
		.WHILE TRUE
			invoke GetMessage,ADDR msg,NULL,0,0
			.BREAK .IF (!eax)
			invoke TranslateMessage,ADDR msg
			invoke DispatchMessage,ADDR msg
		.ENDW
		
			mov	eax,msg.wParam
			ret
	WinMain		ENDP
	
	WndProc		PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
		
			.IF uMsg==WM_DESTROY
	@Destroy:
				invoke EasySound_Stop
				@method lpMyNet,Destructor
				invoke PostQuitMessage,NULL
			.ELSEIF uMsg==WM_CREATE
				push	hWnd
				pop	hMainWnd
				invoke CreateEditBox
				
				invoke GlobalAlloc,GPTR,0400h
				mov	lpBuffer,eax

				invoke Open
				or	eax,eax
				jnz @Destroy
					push	eax
					mov	eax,esp
					invoke ReadFile,hFile,lpBuffer,0400h,eax,NULL
					pop	edx
					PrintDec edx,'fileSize'
					invoke CloseHandle,hFile

				invoke initSound
		; subnet testing
				newObj NET,subnet
				mov	lpMyNet,ecx

				_method Build,lpBuffer			; use loaded data
				;_method Build,offset binData		; use built-in data

				invoke ListInfos,lpMyNet,1

;				invoke NET_getMdlByType,_sin,1
;				invoke NET_freeMdl,eax
;				invoke NET_getMdlByID,1
;				invoke NET_freeMdl,eax
;				invoke NET_getMdlByType,_sin,1
;				invoke NET_freeMdl,eax
;				invoke ListInfos,lpMyNet,1

		; get last module, this will be the terminating output to take the samples from for sound play
				invoke NET_getMdlByID,(NET_CLASS PTR [ecx]).moduleCount

				.IF eax
					invoke NET_buildLiveNet,eax
					;invoke [ecx].MDL_CLASS.lpRun
				.ENDIF

			.ELSE
				invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
				ret
			.ENDIF
			
			xor eax,eax
			ret
	WndProc		ENDP
	
CreateEditBox	PROC
	
		invoke GetClientRect,hMainWnd,addr Rect
		mov	eax,Rect.left
		sub	Rect.right,eax
		mov	eax,Rect.top
		sub	Rect.bottom,eax
		mov	eax,WS_VISIBLE or WS_CHILD or WS_VSCROLL or\
				ES_LEFT or ES_MULTILINE
		invoke CreateWindowEx,NULL,
				addr szEditCtrlClass,NULL,
				eax,
				0,0,Rect.right,Rect.bottom,
				hMainWnd,ID_EDITBOX,
				hInstance,NULL
		or	eax,eax
		jz @End

		mov	hEditBox,eax
		; invoke EnableWindow,hEditBox,FALSE
		invoke GetStockObject,SYSTEM_FIXED_FONT
		mov	hFnt,eax
		invoke SendMessage,hEditBox,WM_SETFONT,hFnt,TRUE	; set font
		mov	eax,1
@End:
		ret
CreateEditBox	ENDP

Open		PROC

		mov	ofn.lStructSize,sizeof OPENFILENAME
		mov	eax,hMainWnd
		mov	ofn.hWndOwner,eax
		mov	eax,hInstance
		mov	ofn.hInstance,eax
		mov	eax,offset szFileFilter
		mov	ofn.lpstrFilter,eax
		mov	ofn.lpstrCustomFilter,NULL
		mov	ofn.nMaxCustFilter,0
		mov	ofn.nFilterIndex,1
		mov	eax,offset szFileName
		mov	ofn.lpstrFile,eax
		mov	ofn.nMaxFile,260
		mov	ofn.lpstrFileTitle,NULL
		  mov	ofn.nMaxFileTitle,0
		mov	ofn.lpstrInitialDir,NULL
		mov	ofn.lpstrTitle,NULL
		mov	ofn.Flags,OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST  or OFN_LONGNAMES
		mov	ofn.lpstrDefExt,NULL
		invoke GetOpenFileName,offset ofn
		or	eax,eax
		jnz @1
		invoke CommDlgExtendedError
		mov	eax,1
		jz @3
			mov	eax,1
			jmp @3
@1:
		invoke CreateFile,addr szFileName,GENERIC_READ,NULL,NULL,OPEN_EXISTING,NULL,NULL
		or	eax,eax
		jnz @2
			mov	eax,1
			jmp @3
@2:
		mov	hFile,eax
		xor	eax,eax
@3:
		ret
Open		ENDP


ListInfos	PROC USES ebx ecx lpNet:DWORD,dwStart:DWORD
		mov	ecx,lpNet
		mov	ebx,dwStart
		_method Info,lpString
		push	ecx
		invoke SendMessage,hEditBox,EM_SETSEL,-1,0
		invoke SendMessage,hEditBox,EM_REPLACESEL,FALSE,lpString
		invoke SendMessage,hEditBox,EM_REPLACESEL,FALSE,offset szBlankRow
		pop	ecx

	@1:
		invoke NET_getMdlByID,ebx
		or	eax,eax
		jz @2
			@method eax,Info,lpString
			push	ecx
			invoke SendMessage,hEditBox,EM_SETSEL,-1,0
			invoke SendMessage,hEditBox,EM_REPLACESEL,FALSE,lpString
			invoke SendMessage,hEditBox,EM_REPLACESEL,FALSE,offset szBlankRow
			pop	ecx
			add	ebx,1
			jmp @1
	@2:
		invoke SendMessage,hEditBox,EM_SETSEL,-1,0
		invoke SendMessage,hEditBox,EM_REPLACESEL,FALSE,offset szBlankRow
		ret
ListInfos	ENDP

soundCallBack	PROC lpSmpBuffer:DWORD,dwNumOfSamples:DWORD

		mov	ebx,dwNumOfSamples
		mov	edi,lpSmpBuffer
		mov	ecx,lpMyNet

	@loop:
		invoke (NET_CLASS PTR [ecx]).lpRun

		push	eax
		fld	SAMPLE PTR [esp]
		pop	eax

		fld	fMaxAmp
		fmul	st(1),st
		fld	fMaxAmp
		fchs
	; st(0): -maxAmp
	; st(1): maxAmp
	; st(2): sample
		fcomp	st(2)
		fstsw	ax
		sahf
		jc @1
;PrintText "-clip"
			fstp	st
			fstp	st
			mov	WORD PTR [edi],08000h
			jmp @3
	@1:
		fcomp	st(1)
		fstsw	ax
		sahf
		jnc @2
;PrintText "+clip"
			fstp	st
			mov	WORD PTR [edi],07FFFh
			jmp @3
	@2:
		fistp	WORD PTR [edi]
	@3:
		add	edi,2
		sub	ebx,1
		jnz @loop

		ret
soundCallBack	ENDP

initSound	PROC

		mov	EasySound_Latency,3000
		invoke EasySound_Start,offset soundCallBack,dwSampleRate,1,0

		ret
initSound	ENDP


	end start