; 
;
; POT CLASS
;
; 


IFNDEF SSN_POT_CLID

		SSN_POT_CLID		EQU __SSN_POT_CLID

; Extern symbols

; Module symbols


newPOT	MACRO
	newObj POT
ENDM

POT_CLASS	STRUCT	; POT class structure

				MDL_CLASS <>			; inheritance
; Private properties
		fMin		SAMPLE ?
		fMax		SAMPLE ?
		fStep		SAMPLE ?

; Public properties

; Virtual functions
		POT_constructor		PROTO CONSTRUCTOR
		; POT_destructor	PROTO DESTRUCTOR
		POT_build		PROTO BUILD
		POT_buildFromXML	PROTO BUILDFROMXML
		POT_export		PROTO EXPORT
		POT_exportToXML		PROTO EXPORTTOXML
		; POT_connect		PROTO CONNECT
		; POT_disconnect	PROTO DISCONNECT
		; POT_getInput		PROTO GETINPUT
		; POT_getOutput		PROTO GETOUTPUT
		POT_info		PROTO INFO
		; POT_reset		PROTO
		; POT_run		PROTO

; Methods
		POT_setMin		PROTO min:PTR SAMPLE
		POT_getMin		PROTO min:PTR SAMPLE
		POT_setMax		PROTO max:PTR SAMPLE
		POT_getMax		PROTO max:PTR SAMPLE
		POT_setStep		PROTO step:PTR SAMPLE
		POT_getStep		PROTO step:PTR SAMPLE

		POT_setValue		PROTO smp:PTR SAMPLE

POT_CLASS	ENDS

ENDIF